// Easy New Notebook
// Jeffrey J Weimer
// SVN History: $Revision: 653 $ on $Date: 2008-04-02 15:18:47 -0500 (Wed, 02 Apr 2008) $

#pragma rtGlobals=1

// PACKAGE GLOBAL FUNCTIONS

#pragma IgorVersion=6.03
#pragma version = 0.20
#pragma ModuleName=ENN

Function IgorMenuHook(isSel, menuStr, itemStr, itemNo, topWindowName, wt)
	Variable isSel, itemNo, wt
	String menuStr, itemStr, topWindowName

	Variable handled= 0
	switch(isSel)
		case 0:
			break
		case 1:
			if ( (cmpstr(menuStr,"New") == 0) && (cmpstr(itemStr,"Notebook") == 0) )
				Execute/P/Q/Z "ENN#CreateNewNotebook()"
				handled= 1
			endif
			break
	endswitch
	return handled
End

Static Function CreateNewNotebook()

	if (DataFolderExists("root:Packages:ENN")==0)
		string cdf=GetDataFolder(1)
		SetDataFolder root:
		NewDataFolder/O/S Packages
		NewDataFolder/O/S ENN
		string/G title
		variable/G left, right, top, bottom
#if(exists("ScreenSizer#Initialize")==6)
		left = 5
		top = 5
		right=30
		bottom = 80
#else
		left = 0
		top = 0
		right = 200
		bottom = 300
#endif
		SetDataFolder $cdf
	endif
	ShowPanel()
	return 0
end

Static Function ShowPanel()

	SVAR title=root:Packages:ENN:title
	NVAR left=root:Packages:ENN:left
	NVAR right=root:Packages:ENN:right
	NVAR top=root:Packages:ENN:top
	NVAR bottom=root:Packages:ENN:bottom

#if(exists("ScreenSizer#Initialize")==6)
	ScreenSizer#Initialize(0)
	left = left*(left<100)
	top = top*(top<100)
	right = right*(right<100)
	right += 30*(right==0)
	bottom = bottom*(bottom<100)
	bottom += 50*(bottom==0)
	ScreenSizer#MakePanel(30,10,(416-150),(166-77),"Easy New Notebook SS",other="/K=1/N=ENN_Panel")
#else
	NewPanel/K=1/N=ENN_Panel/W=(150,77,416,166) as "Easy New Notebook"
#endif
	ModifyPanel noEdit=1,fixedSize=1
	Button doit,pos={212,66},size={50,20},proc=ENN#DoIt,title="Do It"
	CheckBox format,pos={142,25},size={65,14},title="Formatted",value= 1,proc=ENN#SetFormat
	PopupMenu killstate,pos={167,43},size={88,21},title="Kill"
	PopupMenu killstate,mode=1,popvalue="Normal",value= #"\"Normal;Silent;NO KILL;Hide Only;\""
	SetVariable title,pos={7,7},size={250,16},title="Title"
	SetVariable title,value=title
	CheckBox ruler,pos={212,25},size={43,14},title="Ruler",value= 0
	// left
	SetVariable left,pos={5,66},size={70,16},value=left
#if(exists("ScreenSizer#Initialize")==6)
	SetVariable left, title="<%", limits={5,100,5}
#else
	SetVariable left, title="<",limits={10,600,10}
#endif
	// top
	SetVariable top,pos={5,48},size={70,16},value=top
#if(exists("ScreenSizer#Initialize")==6)
	SetVariable top, title="^%", limits={5,100,5}
#else
	SetVariable top, title="^",limits={10,600,10}
#endif
	// bottom
	SetVariable bottom,pos={84,66},size={70,16},value=bottom
#if(exists("ScreenSizer#Initialize")==6)
	SetVariable bottom, title="v%", limits={5,100,5}
#else
	SetVariable bottom, title="v",limits={10,600,10}
#endif
	// right
	SetVariable right,pos={84,48},size={70,16},value=right
#if(exists("ScreenSizer#Initialize")==6)
	SetVariable right, title=">%", limits={5,100,5}
#else
	SetVariable right, title=">",limits={10,600,10}
#endif
	PopupMenu name,pos={7,24},size={116,21},title="Name"
	PopupMenu name,mode=1,popvalue="From Title",value= #"\"From Title;Time Stamp;\""
	
	SetWindow ENN_Panel hook=ENN#closeme
	return 0
End

Static Function CloseMe(infoStr)
	string infoStr

	SVAR title=root:Packages:ENN:title
	
	String event= StringByKey("EVENT",infoStr)
	strswitch(event)
		case "deactivate":
			if (cmpstr(title,"SetMe!")==0)
				title=""
				KillWindow ENN_Panel
				break
			endif
			beep
			DoWindow/F ENN_Panel
			title="SetMe!"
			SetVariable title, activate
			beep
			break
		default:
			break
	endswitch
	return 0
end

Static Function DoIt(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	SVAR title=root:Packages:ENN:title
	NVAR left=root:Packages:ENN:left
	NVAR right=root:Packages:ENN:right
	NVAR top=root:Packages:ENN:top
	NVAR bottom=root:Packages:ENN:bottom

	variable format, kill, ruler
	string name

	switch( ba.eventCode )
		case 2:
			ControlInfo format
			format = V_value
			ControlInfo killstate
			kill = V_value-1
			ControlInfo ruler
			ruler = V_value
			if (strlen(title)==0)
				title="ENNotebook"
			endif
			ControlInfo name
			if (V_value==1)
				name=CleanUpName(title,0)
			else
				name="ENNotebook"+CleanUpName(time(),0)
			endif
			if (strlen(WinList(name,";","WIN:16"))!=0)
				name+="X"
			endif
			KillWindow ENN_Panel
			NewNotebook/K=(kill)/F=(format)/N=$name as title
			if (format)
				Notebook $name showRuler=(ruler)
			endif
#if(exists("ScreenSizer#Initialize")==6)
			ScreenSizer#MoveFrontWindow(left, top, right, bottom)
#else
			MoveWindow left, top, right, bottom
#endif
			break
	endswitch

	return 0
End

Static Function SetFormat(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			checkbox ruler, disable=!cba.checked
			break
	endswitch

	return 0
End
